// Dirt and scratches

sampler2D Tex0 : register( s0 );
sampler2D Tex1 : register( s1 );
sampler2D Tex2 : register( s2 );
sampler2D Tex3 : register( s3 );

float4 c0 : register( c0 );
float4 c7 : register( c7 );

float4 ps_main(
	float4 pos : POSITION ,
	float2 TC0 : TEXCOORD0 ,
	float2 TC1 : TEXCOORD1 ,
	float2 TC2 : TEXCOORD2 ,
	float2 TC3 : TEXCOORD3 ,
	float4 v0 : COLOR0 ,
	float4 v1 : COLOR1 ) : COLOR
{
	float4 t0 = tex2D(Tex0, TC0);
	float4 t1 = tex2D(Tex1, TC1);
	float4 t2 = tex2D(Tex2, TC2);
	float4 t3 = tex2D(Tex3, TC3);
	
	// mad t0.rgb, t0, c7, v1
	t0.rgb = t0.rgb * c7.rgb + v1.rgb;
	// mad t2.rgb, t2, c7, v1
	t2.rgb = t2.rgb * c7.rgb + v1.rgb;

	float4 r0;
	// mad_x2_sat r0.rgb, v0, t1, -c3
	r0.rgb = saturate((v0.rgb * t1.rgb - 0.1) * 2);
	// +mad_x2_sat r0.a, v0.b, t1.b, -c3
	r0.a = saturate((v0.b * t1.b - 0.1) * 2);
	
	// add_x4_sat r0, r0_bx2, ro_bx2
	r0 = saturate((r0 - 0.5) * 2 * 2 * 4);
	
	float4 r1;
	// mul_x2 r1.rgb, t0, c2
	r1.rgb = t0.rgb * 0.3 * 2;
	// +add r1.a, t1.a, c0_bx2.b
	r1.a = t1.a + (c0.b - 0.5) * 2;
	
	// lrp r0.rgb, r0, t2, t1
	r0.rgb = lerp(r1.rgb, t2.rgb, r0.rgb);
	// +add_x4_sat r1.a, r1_bx2.a, c4.a
	r1.a = saturate(((r1.a - 0.5) * 2 + 0.125) * 4);
	
	// mul r1.rgb, t0, t3
	r1.rgb = t0.rgb * t3.rgb;
	// +mul r1.a, r1.a, t3.a
	r1.a = r1.a * t3.a;
	
	// lrp r0.rgb, r1.a, r1, r0
	r0.rgb = lerp(r0.rgb, r1.rgb, r1.a);
	// +mad r0.a, r0.a, 1-r1.a, r1.a
	r0.a = r0.a * (1 - r1.a) + r1.a;

	return r0;
}